package com.sun.corba.se.impl.protocol;

import com.sun.corba.se.spi.oa.OADestroyed;
import com.sun.corba.se.spi.oa.OAInvocationInfo;
import org.omg.CORBA.portable.ServantObject;
import org.omg.CORBA.Object;
import com.sun.corba.se.spi.ior.IOR;
import com.sun.corba.se.spi.orb.ORB;

public class FullServantCacheLocalCRDImpl extends ServantCacheLocalCRDBase
{
    public FullServantCacheLocalCRDImpl(ORB orb, int n, IOR ior) {
        super(orb, n, ior);
    }
    
    public ServantObject servant_preinvoke(org.omg.CORBA.Object object, String s, Class clazz) {
        OAInvocationInfo cachedInfo = this.getCachedInfo();
        if (!this.checkForCompatibleServant(cachedInfo, clazz)) {
            return null;
        }
        OAInvocationInfo oaInvocationInfo = new OAInvocationInfo(cachedInfo, s);
        this.orb.pushInvocationInfo(oaInvocationInfo);
        try {
            oaInvocationInfo.oa().enter();
        }
        catch (OADestroyed oaDestroyed) {
            throw this.wrapper.preinvokePoaDestroyed(oaDestroyed);
        }
        return oaInvocationInfo;
    }
    
    public void servant_postinvoke(org.omg.CORBA.Object object, ServantObject servantObject) {
        this.getCachedInfo().oa().exit();
        this.orb.popInvocationInfo();
    }
}
